package com.y_ys.bench.httpclient ;

import com.y_ys.bench.MBench;

/**
 * HTTPスレッド実行.
 *
 * @version 2008/11/16
 * @author masahito suzuki
 * @since MBench 1.00
 */
public class HttpThread extends Thread {
    private static final int TIMEOUT = 15000 ;
    private HttpAccess access = null ;
    private HttpCounter counter = null ;
    private int wait = 0 ;
    private final AtomicINT startFlag = new AtomicINT( 0 ) ;
    
    private HttpThread() {
        
    }
    
    public HttpThread( HttpCounter counter,String url,HttpHeader header,int wait )
        throws Exception {
        this.access = new HttpAccess( false,header,null,url,TIMEOUT,MBench.USER_AGENT ) ;
        this.counter = counter ;
        this.wait = wait ;
        this.setDaemon( true ) ;
        super.start() ;
    }
    
    public void startThread() {
        startFlag.set( 1 ) ;
    }
    public int getStart() {
        return startFlag.get() ;
    }
    
    public void run() {
        try {
            counter.startThread() ;
            while( getStart() != 1 ) {
                Thread.sleep( 1 ) ;
            }
            HttpResult res = new HttpResult() ;
            if( wait <= 0 ) {
                while(true) {
                    boolean resFlag = false ;
                    long time =System.currentTimeMillis() ;
                    try {
                        resFlag = this.access.execution( res ) ;
                        if( resFlag ) {
                            time = System.currentTimeMillis() - time ;
                            counter.minMaxTime( time ) ;
                            if( !res.isKeepAlive() || res.getKeepAliveCount() <= 1 ) {
                                this.access.close() ;
                            }
                        }
                        else {
                            this.access.close() ;
                        }
                    } catch( Exception e ) {
                        try {
                            this.access.close() ;
                        } catch( Exception ee ) {
                            //System.out.println( ee.getMessage()) ;
                        }
                        //System.out.println( e.getMessage()) ;
                        resFlag = false ;
                    }
                    if( resFlag == false ) {
                        counter.addErrorCount() ;
                    }
                    else {
                        counter.addSuccessCount() ;
                    }
                }
            }
            else {
                while(true) {
                    Thread.sleep( wait ) ;
                    boolean resFlag = false ;
                    long time =System.currentTimeMillis() ;
                    try {
                        resFlag = this.access.execution( res ) ;
                        if( resFlag ) {
                            time = System.currentTimeMillis() - time ;
                            counter.minMaxTime( time ) ;
                            if( !res.isKeepAlive() || res.getKeepAliveCount() <= 1 ) {
                                this.access.close() ;
                            }
                        }
                        else {
                            this.access.close() ;
                        }
                    } catch( Exception e ) {
                        try {
                            this.access.close() ;
                        } catch( Exception ee ) {
                            //System.out.println( ee.getMessage()) ;
                        }
                        //System.out.println( e.getMessage()) ;
                        resFlag = false ;
                    }
                    if( resFlag == false ) {
                        counter.addErrorCount() ;
                    }
                    else {
                        counter.addSuccessCount() ;
                    }
                }
            }
        } catch( Exception e ) {
            //e.printStackTrace() ;
        }
    }
}

